<template>
    <EditableTable
        :table-head="tableHead"
        :table-data="tableData"
        :editableItemId="editableItemId"
        :is-loading-prop="isLoading"
        @openEdit="openEdit"
    >
        <EditingLogisticLeverage
            :logisticLeverageInfo="editableItem"
            @onClose="closeEdit"
        />
    </EditableTable>
</template>

<script>
import {mapState, mapActions} from 'vuex';

export default {
    name: "LogisticLeverage",
    data() {
        return {
            isLoading: false,
            tableHead: [
                {key: 'platform', label: 'Площадка'},
                {key: 'warehouse', label: 'Склад автозаказа'},
                {key: 'logisticLever', label: 'Логистическое плечо, дней'},
            ],
            editableItem: null,
        }
    },
    computed: {
      tableData() {
        const { logisticLeverage } = this.constantsState;
        return logisticLeverage.reduce((resultTableData, dataItem) => {
          try {
            const {id, platform, name, logistic_lever, temporary} = dataItem;
            resultTableData.push({
              id,
              platform: platform.name,
              warehouse: name,
              logisticLever: logistic_lever,
              temporary,
              defaultItem: {...dataItem},
            })
            return resultTableData;
          } catch (e) {
            console.error(e);
            return resultTableData;
          }
        }, []);
      },
      editableItemId() {
        return this.editableItem ? this.editableItem.id : 0;
      },
      ...mapState({constantsState: 'constants'}),
    },
    methods: {
      openEdit(item) {
        const { defaultItem } = item;
        this.editableItem = {...defaultItem};
      },
      closeEdit({closeType, data }) {
        if (closeType) {
          this.changePreloaderState(true, 'Сохранение данных');
          this.editWarehouse({item: this.editableItem, editedItem: data})
          .then(response => {
            this.addToast({
              toastInfo: response.message,
              isVisibleToast: true,
              type: 'success',
            });
            this.editableItem = {};
            if (response.updateTables) {
              return this.getWarehousesCompliancesBoth();
            }
          })
          .catch(response => {
            let message = '';
            if ('message' in response) message = response.message;
            this.addToast({
              toastInfo: message,
              isVisibleToast: true,
            });
          })
          .finally(() => this.changePreloaderState(false, ''))
        } else {
          this.editableItem = {};
        }
      },
      ...mapActions({
        getWarehousesCompliancesBoth: 'getWarehousesCompliancesBoth',
        editWarehouse: 'editWarehouse',
        addToast: 'toast/addToast',
      }),
    }
}
</script>
